function Tree_sum=TreeDecision(Node,Tree,Scale,x,y,IntegralImage,StandardDeviation,InverseAreaa)

% get current classifier
Leaf= Tree(Node+1,:);

% get the haar-feature response
Rectangle_sum = zeros(size(x));
for i_Rectangle = 1:3
    Rectangle = Leaf(:,(1:5)+i_Rectangle*5);
    RectX = floor(Rectangle(:,1)*Scale+x);
    RectY = floor(Rectangle(:,2)*Scale+y);
    RectWidth = floor(Rectangle(:,3)*Scale);
    RectHeight = floor(Rectangle(:,4)*Scale);
    RectWeight = Rectangle(:,5);
    r_sum = SumRect(IntegralImage,RectX,RectY,RectWidth,RectHeight).*RectWeight;
    Rectangle_sum = Rectangle_sum + r_sum;
end
Rectangle_sum = Rectangle_sum * InverseAreaa;

% get the values of the current classifier
LeafTreshold=Leaf(:,1);
LeftValue = Leaf(:,2);
RightValue =Leaf(:,3);
LeftNode = Leaf(:,4);
RightNode =Leaf(:,5);

% Compare the haar-response and the threshold of classifier
Node=zeros(size(x));
Tree_sum =zeros(size(x));
D=Rectangle_sum >= LeafTreshold(:).*StandardDeviation;
Node(D) =RightNode(D);
Node(~D)=LeftNode(~D);
Tree_sum(D)=RightValue(D);
Tree_sum(~D)=LeftValue(~D);

% If a Node has a larger value than -1, it is connected to another weak-classifier
D=Node>-1;
if(any(D))
    Tree_sum(D)=TreeDecision(Node(D),Tree,Scale,x(D),y(D),IntegralImage,StandardDeviation(D),InverseAreaa);
end
