function face= VJFaceDetection(IntegralImages,TrainDetector,Options)

% get image scale
ScaleWidth = IntegralImages.width/TrainDetector.size(1);
ScaleHeight = IntegralImages.height/TrainDetector.size(2);
if(ScaleHeight < ScaleWidth ), 
    StartScale =  ScaleHeight; 
else
    StartScale = ScaleWidth;
end

% save the detected face
face=zeros(20,4); 

%the number of scales that need to test
numofscale=ceil(log(1/StartScale)/log(Options.ScaleUpdate));
%number of face that detected
n=0;
for i=1:numofscale
    Scale =StartScale*Options.ScaleUpdate^(i-1);    

    w = floor(TrainDetector.size(1)*Scale);
    h = floor(TrainDetector.size(2)*Scale);

    %search coordinates step
    step = floor(max( Scale, 2 ));

    % get search coordinates 
    [x,y]=ndgrid(0:step:(IntegralImages.width-w-1),0:step:(IntegralImages.height-h-1)); 
    x=x(:); y=y(:);
    
    if(isempty(x))
        continue; 
    end
    
    % Find face in the image for the current scale
    [x,y] = FaceDetection( x, y, Scale, IntegralImages, w, h, TrainDetector);
     
    % get face positions
    for k=1:length(x);
        n=n+1;
        face(n,:)=[x(k) y(k) w h];
    end
end
face=face(1:n,:);
face=face*IntegralImages.Ratio;